<?php

namespace App\Livewire\Studio\Catalog;

use App\Livewire\Forms\Studio\Catalog\CategoryForm;
use App\Models\Category as CategoryModel;
use App\Traits\WithAuthorization;
use App\Traits\WithCloseModal;
use App\Traits\WithConfirmation;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Flux\Flux;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Kategori')]
class Category extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithToast, WithUpdatedData;

    public CategoryForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null)
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        if ($id) {
            $this->form->setCategory(CategoryModel::byHashOrFail($id));
        }
    }

    public function create()
    {
        $this->canOrAbort('create category');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('Kategori berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update()
    {
        $this->canOrAbort('update category');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('Kategori berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(CategoryModel $category)
    {
        $this->form->category = $category;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('Kategori berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('fn:sortOrder')]
    public function sortOrder(CategoryModel $category, string $direction)
    {
        $this->canOrAbort('update category');

        $this->form->category = $category;

        $this->form->sortOrder($direction);

        $this->dispatch('refreshDatatable');
    }

    public function render()
    {
        return view('livewire.studio.catalog.categories', [
            'pageTitle' => 'Kategori',
        ]);
    }
}
